
yarip.Page = function(name)
{
	this.name = "";
	this.whitelist = new yarip.List("whitelist");
	this.blacklist = new yarip.List("blacklist");

	this.setName = function(pName)
	{
		if (pName) this.name = "" + pName;
	};

	this.reset = function()
	{
		this.whitelist.reset();
		this.blacklist.reset();
	};

	this.generateXml = function()
	{
		var tmp = this.whitelist.generateXml() + this.blacklist.generateXml();
		if (tmp != "") return "\t<page name=\"" + this.name + "\">\n" + tmp + "\t</page>\n";
		else return "";
	};

	this.setName(name);
};

yarip.PageSorter = function(a, b)
{
	var aArr = a.name.match(yarip.domainRegExp)[0].split('.').reverse();
	var bArr = b.name.match(yarip.domainRegExp)[0].split('.').reverse();
	for (var i = 1; i >= 0; i--)
	{
		if (aArr[i] < bArr[i]) return -1;
		if (aArr[i] > bArr[i]) return 1;
	}
	for (var i = 2; i < aArr.length && i < bArr.length; i++)
	{
		if (aArr[i] < bArr[i]) return -1;
		if (aArr[i] > bArr[i]) return 1;
	}
	if (aArr.length < bArr.length) return -1;
	if (aArr.length > bArr.length) return 1;

	var aIsDomain = a.name.search(/^[^:/?&#]+$/) > -1;
	var bIsDomain = b.name.search(/^[^:/?&#]+$/) > -1;

	if (aIsDomain && bIsDomain) return 0;
	if (aIsDomain && !bIsDomain) return -1;
	if (!aIsDomain && bIsDomain) return 1;
	return yarip.normalSort(a.name, b.name);
};
